package tools;

public class FieldParser {

  String sep;
  boolean eos= false;

  String str;
  int idx= 0;
  int len;

  public FieldParser(String str, String sep) {
    this.str= str;
    this.sep= sep;
    len= str.length();
  }

  public String readString() {
    if (idx>len) {
      eos= true;
      return null;
    }

    int nextIdx= str.indexOf(sep, idx);
    if (nextIdx==-1) nextIdx= len;

    String token= str.substring(idx, nextIdx);
    idx= nextIdx+1;
    return token;
  }

  public String readLine() {
    if (idx>len) {
      eos= true;
      return "";
    }

    int prevIdx= idx;
    idx= str.length();
    return str.substring(prevIdx);
  }

  public boolean eosReached() { return eos; }
  public boolean hasMoreFields() { return idx<len; }

  public int readInt() {
    String str= readString();
    return eos ? 0 : Integer.parseInt(str);
  }

  public double readDouble() {
    String str= readString();
    return eos ? 0. : new Double(str).doubleValue();
  }

  public boolean readBoolean() {
    String str= readString();
    if (str.equals("true"))
      return true;
    else if (str.equals("false"))
      return false;
    else
      Tools.fatalError("readBoolean() has not read true or false");
    return false;
  }
}
