package tools;

import java.io.*;

public class FieldTextReader extends GenericTextReader {

  BufferedReader in;  // El reader estandar usado
  String fn;          // El nombre del archivo para debugging
  int eofCount= 0;    // Se usa para contar cuantas veces se ha leido
                      // despues del eof
  public static final int MAXEOFCOUNT= 100;

  String line= null;  // Un linea del archivo
  String sep;
  FieldParser parser;

  // Constructor
  public FieldTextReader(String fn, String sep) {
    this.sep= sep;
    try {
      in= new BufferedReader(new FileReader(fn));
      this.fn= fn;
    }
    catch ( FileNotFoundException excp) {
      throw new FileNotFoundExcp("File "+fn+" not found.");
    }
    catch ( IOException excp ) {
      throw new ProgramException (
        "An input exception happened while opening file "+fn, excp);
    }
    skip();
  }

  public void close() {
    try {
      in.close();
    }
    catch ( IOException excp ) {
      throw new ProgramException (
        "An input exception happened while closing file "+fn, excp);
    }
  }

  public boolean eofReached() { return eofCount!=0; }
  public boolean hasMoreFields() { return parser.hasMoreFields(); }

  public String readLine() {
    String str= parser.readLine();
    skip();
    return str;
  }

  public String readString() {
    if (!parser.hasMoreFields())
      Tools.fatalError("End of line reached while reading file "+fn);
    return parser.readString();
  }

  public int readInt() {
    if (!parser.hasMoreFields())
      Tools.fatalError("End of line reached while reading file "+fn);
    return parser.readInt();
  }

  public double readDouble() {
    if (!parser.hasMoreFields())
      Tools.fatalError("End of line reached while reading file "+fn);
    return parser.readDouble();
  }

  public boolean readBoolean() {
    if (!parser.hasMoreFields())
      Tools.fatalError("End of line reached while reading file "+fn);
    return parser.readBoolean();
  }

  public void skip() {
    try {
      if (eofCount==0) {
        line= in.readLine(); // Puede lanzar IOException
        if (line==null)
          eofCount= 1;
        else
          parser= new FieldParser(line, sep);
      }
      else if (eofCount>=MAXEOFCOUNT)
        Tools.fatalError(
          "You have read "+MAXEOFCOUNT+" times after the end of file "+fn+
          ".  One read should be enough.  You have an infinite loop");
      else
        eofCount++;
    }
    catch ( IOException excp ) {
      throw new ProgramException(
        "An input exception happened while reading file "+fn, excp);
    }
  }
}
