package tools;

import java.io.*;

public class FieldTextWriter extends RawTextWriter {

  String sep;
  boolean first= false; // Has the first field been written?

  public FieldTextWriter(String fn, String sep) {
    super(fn);
    this.sep= sep;
  }

  public void print(int n) { printSep(); super.print(n); }
  public void print(double x) { printSep(); super.print(x); }

  public void print(String s) {
    if (s.indexOf(sep)>=0)
      Tools.fatalError("Can't write the separator "+sep+" as part of the "+
                       "string to be written.  The string was:\n"+s);
    printSep(); super.print(s);
  }

  public void println() {
    super.println();
    first= false;
  }

  private void printSep() {
    if (first)
      super.print(sep);
    first= true;
  }
}
