package tools;

public abstract class TextConsole {

  // Manejo de la salida en la consola

  public abstract void print(String s);
  public abstract void println();

  public void print(char c) { print(""+c); }
  public void print(int n) { print(""+n); }
  public void print(long n) { print(""+n); }
  public void print(double x) { print(""+x); }
  public void print(float x) { print(""+x); }
  public void print(boolean b) { print(b?"true":"false");}
  public void println(String s) { print(s); println(); }
  public void println(char c) { print(c); println(); }
  public void println(int n) { print(n); println(); }
  public void println(long n) { print(n); println(); }
  public void println(double x) { print(x); println(); }
  public void println(float x) { print(x); println(); }
  public void println(boolean b) { print(b); println(); }

  // Manejo de la entrada en la consola

  public abstract String readLine();
  public abstract String readString();
  public int readInt() { return Tools.parseInt(readString()); }
  public double readDouble() { return Tools.parseDouble(readString()); }
  public boolean readBoolean() {
    String s= Tools.trim(Tools.lower(readString()));
    if (Tools.compare(s,"true")==0)
      return true;
    else if (Tools.compare(s,"false")==0)
      return false;
    else
      Tools.fatalError("readBoolean() has not read true or false "+
                       "from console input");
    return false;
  }
}
